
//	Copyright 2010 Ohtan's Design Corporation

//	rtcc.c

// ===========================================================================
// =	CL^										@@@@@@					 =
// ===========================================================================
//	002 2010.10.17
//	E{^̒ǉ(ݒύXj
// ---------------------------------------------------------------------------
//	001 2010.10.14
//	EVK쐬
//  Crated by A.Ohta
// ===========================================================================


// ***************************************************************************
//		PIC24FJ64GA002 RTCC@\
// ***************************************************************************


// ***************************************************************************
// *	zdl																 *
// ***************************************************************************
/*
	NOKIA 5110 LCD ]TvvO	PIC24FJ64GA002  CLOCK:8MHz Vdd = 3.3V

	RA0:
	RA1:
	RA2:
	RA3:
	RA4:SOSCO						Rs = 1MHz,X1:32.768kHz,C = 15pF

	RB0:
	RB1:
	RB2:
	RB3:
	RB4:SOSCI						X1:32.768kHz,C = 15pF
	RB5:
	RB6:
	RB7:

	RB8:
	RB9:
	RB10:
	RB11:
	RB12:
	RB13:
	RB14:RTCC		igpj			1Hz Clock out/Alarm
	RB15:

	EOtBbNLCDƂ̒ʐMC^tF[X͐prohʐMB

*/

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************
// ***************************************************************************
#include	"p24FJ64GA002.h"

	//	***** 錾 *****

#include	"_AtrDef24f.h"												//	萔Af[^^̐錾

#include	"rtcc.h"

#include	"nokiaGlcdlib.h"

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************

unsigned int readTimeDate[4];											// RTCC̎f[^obt@

extern int rtccYearH;															// for BCD Year H
extern int rtccYearL;															// for BCD Year L
extern int rtccMonthH;															// for BCD Month H
extern int rtccMonthL;															// for BCD Month L
extern int rtccDayH;															// for BCD Day H
extern int rtccDayL;															// for BCD Day L

extern int rtccHourH;															// for BCD Hour H
extern int rtccHourL;															// for BCD Hour L
extern int rtccMinH;															// for BCD Min H
extern int rtccMinL;															// for BCD Min L
extern int rtccSecH;															// for BCD Sec H
extern int rtccSecL;															// for BCD Sec L

// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************
// ***************************************************************************

//============================================================================
//	RTCC̏ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ohb}CR@\RTCCݒ肵܂B
//============================================================================
void	RtccInit(void)
{
	soscok();															// SOSCJn

	lockfree();															// RTCCݒV[PX

	RCFGCAL = 0xAC00;													// RTCC on Start
	PADCFG1bits.RTSECSEL = 1;											// RTCC Clock out
	RCFGCALbits.RTCPTR = 3;												// RTCC access(Write)
	RTCVAL = 0x0010;													// y = 2010
	RTCVAL = 0x0101;													// m,d
	RTCVAL = 0x0500;													// week,hour
	RTCVAL = 0x0000;													// min,sec
	RCFGCALbits.RTCWREN = 0;											// RTCCݒIbN

	ALCFGRPT = 0x0000;													// A[off
																		// RTCC荞ݐݒ
	IPC15bits.RTCIP = 5;												// 荞݃x5
	IEC3bits.RTCIE = 1;													// 荞݋
																		//  2010/01/01(Fri.)
}

//============================================================================
//	RTCC@AbN
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	RTCC AbNV[PXARCFGCALRTCWRENrbg̃Zbg
//============================================================================
void lockfree(void)
{
	asm volatile("disi	#5");
	asm volatile("mov	#0x55, w7");
	asm volatile("mov	w7, _NVMKEY");
	asm volatile("mov	#0xAA, w8");
	asm volatile("mov	w8, _NVMKEY");
	asm volatile("bset	_RCFGCAL, #13");
	asm volatile("nop");
	asm volatile("nop");
}

//============================================================================
//	SOSC@̔ULɂ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void soscok(void)
{
	asm("mov	#OSCCON, w1");
	asm("mov.b	#0x32, w0");
	asm("mov	#0x46, w2");
	asm("mov	#0x57, w3");
	asm("mov.b	w2, [w1]");
	asm("mov.b	w3, [w1]");
	asm("mov.b	w0, [w1]");
}

//============================================================================
//	RTCC@甭ULɂtƎǂݏo
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void readRTCC(void)
{
			//	***** ݎǂݏo *****

			RCFGCALbits.RTCPTR = 3;										// |C^Zbg
			readTimeDate[0] = RTCVAL;									// * year
			readTimeDate[1] = RTCVAL;									// month day
			readTimeDate[2] = RTCVAL;									// week hour
			readTimeDate[3] = RTCVAL;									// min sec

			// Set to LCD Buffer

			rtccYearH  = ((readTimeDate[0] >> 4) & 0x0F);				// BCD year H
			rtccYearL  = (readTimeDate[0] & 0x0F);						// BCD year L
			rtccMonthH = ((readTimeDate[1] >> 12) & 0x0F);				// BCD month H
			rtccMonthL = ((readTimeDate[1] >> 8) & 0x0F);				// BCD month L
			rtccDayH   = ((readTimeDate[1] >> 4) & 0x0F);				// BCD day H
			rtccDayL   = (readTimeDate[1] & 0x0F);						// BCD day L

			rtccHourH  = ((readTimeDate[2] >> 4) & 0x0F);				// BCD hour H
			rtccHourL  = (readTimeDate[2] & 0x0F);						// BCD hour L
			rtccMinH   = ((readTimeDate[3] >> 12) & 0x0F);				// BCD min H
			rtccMinL   = ((readTimeDate[3] >>8) & 0x0F);				// BCD min L
			rtccSecH  = ((readTimeDate[3] >> 4) & 0x0F);				// BCD sec H
			rtccSecL  = (readTimeDate[3] & 0x0F);						// BCD sec L
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************


//	Copyright 2010 Ohtan's Design Corporation

